char globus_i_gram_default_rvf[] = "\
# RSL Validation Information for the base RSL supported by the job\n\
# manager\n\
Attribute: directory\n\
Description: \"Specifies the path of the directory the jobmanager will use as\n\
              the default directory for the requested job.\"\n\
Default: $(HOME)\n\
ValidWhen: GLOBUS_GRAM_JOB_SUBMIT\n\
DefaultWhen: GLOBUS_GRAM_JOB_SUBMIT\n\
\n\
\n\
Attribute: executable\n\
Description: \"The name of the executable file to run on the remote machine.\n\
	      If the value is a GASS URL, the file is transferred to the\n\
	      remote gass cache before executing the job and removed after\n\
	      the job has terminated.\"\n\
ValidWhen: GLOBUS_GRAM_JOB_SUBMIT\n\
RequiredWhen: GLOBUS_GRAM_JOB_SUBMIT\n\
\n\
Attribute: arguments\n\
Description: \"The command line arguments for the executable. Use quotes, if a\n\
	      space is required in a single argument.\"\n\
ValidWhen: GLOBUS_GRAM_JOB_SUBMIT\n\
\n\
Attribute: stdin\n\
Description: \"The name of the file to be used as standard input for the\n\
	      executable on the remote machine. If the value is a GASS URL,\n\
	      the file is transferred to the remote gass cache before\n\
	      executing the job and removed after the job has terminated.\"\n\
Default: \"/dev/null\"\n\
ValidWhen: GLOBUS_GRAM_JOB_SUBMIT\n\
DefaultWhen: GLOBUS_GRAM_JOB_SUBMIT\n\
\n\
Attribute: stdout\n\
Description: \"The name of the remote file to store the standard output from\n\
	      the job. If the value is a GASS URL, the standard output from\n\
	      the job is transferred dynamically during the execution of the\n\
	      job. There are two accepted forms of this value. It can consist\n\
              of a single destination: stdout = URL, or a sequence of\n\
              destinations: stdout = (DESTINATION) (DESTINATION). In the latter\n\
              case, the DESTINATION may itself be a URL or a sequence of an\n\
              x-gass-cache URL followed by a cache tag.\"\n\
Default: \"/dev/null\"\n\
ValidWhen: GLOBUS_GRAM_JOB_SUBMIT GLOBUS_GRAM_JOB_MANAGER_RESTART GLOBUS_GRAM_JOB_MANAGER_STDIO_UPDATE\n\
DefaultWhen: GLOBUS_GRAM_JOB_SUBMIT \n\
\n\
Attribute: stderr\n\
Description: \"The name of the remote file to store the standard error from\n\
	      the job. If the value is a GASS URL, the standard error from\n\
	      the job is transferred dynamically during the execution of the\n\
	      job.  There are two accepted forms of this value. It can consist\n\
              of a single destination: stderr = URL, or a sequence of\n\
              destinations: stderr = (DESTINATION) (DESTINATION). In the latter\n\
              case, the DESTINATION may itself be a URL or a sequence of an\n\
              x-gass-cache URL followed by a cache tag.\"\n\
Default: \"/dev/null\"\n\
ValidWhen: GLOBUS_GRAM_JOB_SUBMIT GLOBUS_GRAM_JOB_MANAGER_RESTART GLOBUS_GRAM_JOB_MANAGER_STDIO_UPDATE\n\
DefaultWhen: GLOBUS_GRAM_JOB_SUBMIT \n\
\n\
Attribute: count\n\
Description: \"The number of executions of the executable.\"\n\
Default: 1\n\
ValidWhen: GLOBUS_GRAM_JOB_SUBMIT\n\
DefaultWhen: GLOBUS_GRAM_JOB_SUBMIT\n\
\n\
Attribute: environment\n\
Description: \"The environment variables that will be defined for the\n\
	      executable in addition to default set that is given to the job\n\
	      by the jobmanager.\"\n\
ValidWhen: GLOBUS_GRAM_JOB_SUBMIT\n\
\n\
Attribute: max_time\n\
Description: \"The maximum walltime or cputime for a single execution of the\n\
	      executable. Walltime or cputime is selected by the GRAM\n\
	      scheduler being interfaced. The units is in minutes. The value\n\
	      will go through an atoi() conversion in order to get an\n\
	      integer.\"\n\
ValidWhen: GLOBUS_GRAM_JOB_SUBMIT\n\
\n\
Attribute: max_wall_time\n\
Description: \"Explicitly set the maximum walltime for a single execution of\n\
	      the executable. The units is in minutes. The value will go\n\
	      through an atoi() conversion in order to get an integer. If the\n\
	      GRAM scheduler cannot set walltime, then an error will be\n\
	      returned. \"\n\
ValidWhen: GLOBUS_GRAM_JOB_SUBMIT\n\
\n\
Attribute: max_cpu_time\n\
Description: \"Explicitly set the maximum cputime for a single execution of\n\
	      the executable. The units is in minutes. The value will go\n\
	      through an atoi() conversion in order to get an integer. If the\n\
	      GRAM scheduler cannot set cputime, then an error will be\n\
	      returned.\"\n\
ValidWhen: GLOBUS_GRAM_JOB_SUBMIT\n\
\n\
Attribute: job_type\n\
Description: \"This specifies how the jobmanager should start the job.\n\
              Possible values are single (even if the count > 1, only start\n\
	      1 process or thread), multiple (start count processes or threads),\n\
	      mpi (use the appropriate method (e.g. mpirun) to start a program\n\
	      compiled with a vendor-provided MPI library. Program is started\n\
	      with count nodes), and condor (starts condor jobs in the\n\
	      \\\"condor\\\" universe.)\"\n\
Values: single multiple mpi condor\n\
Default: multiple\n\
ValidWhen: GLOBUS_GRAM_JOB_SUBMIT\n\
DefaultWhen: GLOBUS_GRAM_JOB_SUBMIT\n\
\n\
Attribute: gram_my_job\n\
Description: \"Obsolete and ignored.\"\n\
Values: collective independent\n\
Default: collective\n\
ValidWhen: GLOBUS_GRAM_JOB_SUBMIT\n\
DefaultWhen: GLOBUS_GRAM_JOB_SUBMIT\n\
\n\
Attribute: queue\n\
Description: \"Target the job to a queue (class) name as defined by the\n\
	      scheduler at the defined (remote) resource.\"\n\
ValidWhen: GLOBUS_GRAM_JOB_SUBMIT\n\
\n\
Attribute: project\n\
Description: \"Target the job to be allocated to a project account as defined\n\
	      by the scheduler at the defined (remote) resource.\"\n\
ValidWhen: GLOBUS_GRAM_JOB_SUBMIT\n\
\n\
Attribute: host_count\n\
Description: \"Only applies to clusters of SMP computers, such as newer IBM SP\n\
	      systems. Defines the number of nodes (\\\"pizza boxes\\\") to\n\
	      distribute the \\\"count\\\" processes across.\"\n\
ValidWhen: GLOBUS_GRAM_JOB_SUBMIT\n\
\n\
Attribute: dry_run\n\
Description: \"If dryrun = yes then the jobmanager will not submit the job for\n\
	      execution and will return success.\"\n\
Default: no\n\
Values: yes no\n\
ValidWhen: GLOBUS_GRAM_JOB_SUBMIT\n\
DefaultWhen: GLOBUS_GRAM_JOB_SUBMIT\n\
\n\
Attribute: min_memory\n\
Description: \"Explicitly set the minimum amount of memory for a single execution\n\
              of the executable. The units is in Megabytes. The value will go\n\
	      through an atoi() conversion in order to get an integer. If the\n\
	      GRAM scheduler cannot set minMemory, then an error will be\n\
	      returned.\"\n\
ValidWhen: GLOBUS_GRAM_JOB_SUBMIT\n\
\n\
Attribute: max_memory\n\
Description: \"Explicitly set the maximum amount of memory for a single execution\n\
              of the executable. The units is in Megabytes. The value will go\n\
	      through an atoi() conversion in order to get an integer. If the\n\
	      GRAM scheduler cannot set maxMemory, then an error will be\n\
	      returned.\"\n\
ValidWhen: GLOBUS_GRAM_JOB_SUBMIT\n\
\n\
Attribute: save_state\n\
Description: \"Causes the jobmanager to save it's job state information to a\n\
	      persistent file on disk. If the job manager exits or is\n\
	      suspended, the client can later start up a new job manager   \n\
	      which can continue monitoring the job.\"\n\
Values: yes no\n\
ValidWhen: GLOBUS_GRAM_JOB_SUBMIT\n\
\n\
Attribute: two_phase\n\
Description: \"Use a two-phase commit for job submission and completion. The\n\
	      job manager will respond to the initial job request with a\n\
	      WAITING_FOR_COMMIT error. It will then wait for a signal from\n\
	      the client before doing the actual job submission. The integer\n\
	      supplied is the number of seconds the job manager should wait\n\
	      before timing out. If the job manager times out before\n\
	      receiving the commit signal, or if a client issues a cancel\n\
	      signal, the job manager will clean up the job's files and exit,\n\
	      sending a callback with the job status as\n\
	      GLOBUS_GRAM_PROTOCOL_JOB_STATE_FAILED.\n\
	      After the job manager sends a DONE or FAILED callback, it will\n\
	      wait for a commit signal from the client. If it receives one,\n\
	      it cleans up and exits as usual. If it times out and save_state\n\
	      was enabled, it will leave all of the job's files in place and\n\
	      exit (assuming the client is down and will attempt a job\n\
	      restart later). The timeoutvalue can be extended via a signal.\n\
	      When one of the following errors occurs, the job manager does\n\
	      not delete the job state file when it exits:\n\
	      GLOBUS_GRAM_PROTOCOL_ERROR_COMMIT_TIMED_OUT,\n\
	      GLOBUS_GRAM_PROTOCOL_ERROR_TTL_EXPIRED,\n\
	      GLOBUS_GRAM_PROTOCOL_ERROR_JM_STOPPED,\n\
	      GLOBUS_GRAM_PROTOCOL_ERROR_USER_PROXY_EXPIRED.\n\
	      In these cases, it can not be restarted, so the job manager  \n\
	      will not wait for the commit signal after sending the FAILED\n\
	      callback\"\n\
ValidWhen: GLOBUS_GRAM_JOB_SUBMIT\n\
\n\
Attribute: remote_io_url\n\
Description: \"Writes the given value (a URL base string) to a file, and adds\n\
	      the path to that file to the environment through the\n\
	      GLOBUS_REMOTE_IO_URL environment variable. If this is specified\n\
	      as part of a job restart RSL, the job manager will update the\n\
	      file's contents. This is intended for jobs that want to access\n\
	      files via GASS, but the URL of the GASS server has changed due\n\
	      to a GASS server restart.\"\n\
ValidWhen: GLOBUS_GRAM_JOB_SUBMIT GLOBUS_GRAM_JOB_MANAGER_RESTART GLOBUS_GRAM_JOB_MANAGER_STDIO_UPDATE\n\
\n\
Attribute: scratch_dir\n\
Description: \"Specifies the location to create a scratch subdirectory in.\n\
	      A SCRATCH_DIRECTORY RSL substitution will be filled with the\n\
	      name of the directory which is created.\"\n\
ValidWhen: GLOBUS_GRAM_JOB_SUBMIT\n\
\n\
Attribute: rsl_substitution\n\
Description: \"Specifies a list of values which can be substituted into other\n\
              rsl attributes' values through the $(SUBSTITUTION) mechanism.\"\n\
ValidWhen: GLOBUS_GRAM_JOB_SUBMIT GLOBUS_GRAM_JOB_MANAGER_RESTART\n\
\n\
Attribute: restart\n\
Description: \"Start a new job manager, but instead of submitting a new job,\n\
          start managing an existing job. The job manager will search for\n\
          the job state file created by the original job manager. If it\n\
          finds the file and successfully reads it, it will become the\n\
          new manager of the job, sending callbacks on status and\n\
          streaming stdout/err if appropriate. It will fail if it detects\n\
          that the old jobmanager is still alive (via a timestamp in the\n\
          state file). If stdout or stderr was being streamed over the\n\
          network, new stdout and stderr attributes can be specified in \n\
          the restart RSL and the jobmanager will stream to the new\n\
          locations (useful when output is going to a GASS server started\n\
          by the client that's listening on a dynamic port, and the\n\
          client was restarted). The new job manager will return a new\n\
          contact string that should be used to communicate with it. If a\n\
          jobmanager is restarted multiple times, any of the previous   \n\
          contact strings can be given for the restart attribute.\"\n\
RequiredWhen: GLOBUS_GRAM_JOB_MANAGER_RESTART\n\
ValidWhen: GLOBUS_GRAM_JOB_MANAGER_RESTART\n\
\n\
Attribute: stdout_position\n\
Description: \"Specifies where in the file remote output streaming should be\n\
              restarted from. Must be 0.\"\n\
ValidWhen: GLOBUS_GRAM_JOB_MANAGER_RESTART GLOBUS_GRAM_JOB_MANAGER_STDIO_UPDATE\n\
Values: 0\n\
\n\
Attribute: stderr_position\n\
Description: \"Specifies where in the file remote standard error streaming\n\
              should be restarted from. Must be 0.\"\n\
ValidWhen: GLOBUS_GRAM_JOB_MANAGER_RESTART GLOBUS_GRAM_JOB_MANAGER_STDIO_UPDATE\n\
Values: 0\n\
\n\
Attribute: file_stage_in\n\
Description: \"Specifies a list of (\\\"remote URL\\\" \\\"local file\\\") pairs which\n\
              indicate files to be staged to the nodes which will run the\n\
	      job.\"\n\
ValidWhen: GLOBUS_GRAM_JOB_SUBMIT\n\
\n\
Attribute: file_stage_in_shared\n\
Description: \"Specifies a list of (\\\"remote URL\\\" \\\"local file\\\") pairs which\n\
              indicate files to be staged into the cache. A symlink from the\n\
	      cache to the \\\"local file\\\" path will be made.\"\n\
ValidWhen: GLOBUS_GRAM_JOB_SUBMIT\n\
\n\
Attribute: file_stage_out\n\
Description: \"Specifies a list of (\\\"local file\\\" \\\"remote URL\\\") pairs which\n\
              indicate files to be staged from the job to a GASS-compatible\n\
	      file server.\"\n\
ValidWhen: GLOBUS_GRAM_JOB_SUBMIT\n\
\n\
Attribute: file_clean_up\n\
Description: \"Specifies a list of files which will be removed after the job\n\
              is completed.\"\n\
ValidWhen: GLOBUS_GRAM_JOB_SUBMIT\n\
\n\
Attribute: gass_cache\n\
Description: Specifies location to override the GASS cache location.\n\
ValidWhen: GLOBUS_GRAM_JOB_SUBMIT\n\
\n\
Attribute: proxy_timeout\n\
Description: \"Obsolete and ignored. Now a job-manager-wide setting.\"\n\
ValidWhen: GLOBUS_GRAM_JOB_SUBMIT GLOBUS_GRAM_JOB_MANAGER_RESTART\n\
\n\
Attribute: library_path\n\
Description: \"Specifies a list of paths to be appended to the system-specific\n\
              library path environment variables.\"\n\
Default: $(GLOBUS_LOCATION)/lib\n\
DefaultWhen: GLOBUS_GRAM_JOB_SUBMIT\n\
ValidWhen: GLOBUS_GRAM_JOB_SUBMIT\n\
\n\
Attribute: username\n\
Description: Verify that the job is running as this user.\n\
ValidWhen: GLOBUS_GRAM_JOB_SUBMIT\n\
\n\
Attribute: restartcontacts\n\
Description: \"When restarting, use job state callback contacts from the \n\
             original request. Internally generated.\"\n\
ValidWhen: GLOBUS_GRAM_JOB_MANAGER_RESTART\n\
Values: yes no\n\
Default: no\n\
DefaultWhen: GLOBUS_GRAM_JOB_MANAGER_RESTART\n\
Publish: false\n\
\n\
Attribute: savejobdescription\n\
Description: \"Save a copy of the job description to $HOME\"\n\
ValidWhen: GLOBUS_GRAM_JOB_SUBMIT\n\
Values: yes no\n\
Default: no\n\
DefaultWhen: GLOBUS_GRAM_JOB_SUBMIT\n\
\n\
Attribute: loglevel\n\
Description: \"Override the default log level for this job. The value of this\n\
             attribute consists of a combination of the strings\n\
             FATAL, ERROR, WARN, INFO, DEBUG, TRACE joined by the | character\"\n\
ValidWhen: GLOBUS_GRAM_JOB_SUBMIT\n\
\n\
Attribute: logpattern\n\
Description: \"Override the default log path pattern for this job. The value of\n\
             this attribute is a string (potentially containing RSL\n\
             substitutions) that is evaluated to the path to write the log to.\n\
             If the resulting string contains the string $(DATE) (or any other\n\
             RSL substitution), it will be reevaluated at log time.\"\n\
ValidWhen: GLOBUS_GRAM_JOB_SUBMIT\n\
\n\
# default value is 4 hours\n\
Attribute: expiration\n\
Description: \"Time (in seconds) after a a job fails to receive a two-phase\n\
              commit end signal before it is cleaned up.\"\n\
ValidWhen: GLOBUS_GRAM_JOB_SUBMIT\n\
Default: 14400\n\
DefaultWhen: GLOBUS_GRAM_JOB_SUBMIT\n\
";
